<?php

namespace App\State\Processor;

use ApiPlatform\Metadata\Delete;
use ApiPlatform\Metadata\Operation;
use ApiPlatform\Metadata\Patch;
use ApiPlatform\Metadata\Post;
use ApiPlatform\Metadata\Put;
use ApiPlatform\State\ProcessorInterface;
use ApiPlatform\Validator\ValidatorInterface;
use App\Dto\Input\CommandTaskInput;
use App\Dto\Output\CommandTaskOutput;
use App\Repository\CommandTaskRepository;
use App\Service\CreateTraceService;

readonly class CommandTaskProcessor implements ProcessorInterface
{
    public function __construct(
        private CommandTaskRepository               $commandTaskRepository,
        private ValidatorInterface                  $validator
    )
    {
    }

    /**
     * @throws \Exception
     */
    public function process(mixed $data, Operation $operation, array $uriVariables = [], array $context = [])
    {
        switch ($operation){
            case $operation instanceof Post:
            case $operation instanceof Put:
            case $operation instanceof Patch:
                return $this->processCreateOrUpdate($data, $operation, $uriVariables, $context);
            case $operation instanceof Delete:
                return $this->processDelete($data, $operation, $uriVariables, $context);
        }
    }

    /**
     * @throws \Exception
     */
    private function processCreateOrUpdate($data, Operation $operation, array $uriVariables = [], array $context = []): CommandTaskOutput
    {
        if (!($data instanceof CommandTaskInput)) {
            throw new \Exception(sprintf('data is not instance of %s', CommandTaskInput::class));
        }

        $entity = null;
        if (isset($uriVariables['uuid'])) {
            $entity = $this->commandTaskRepository->findOneByUuid($uriVariables['uuid']);
        }

        $task = $data->createOrUpdateEntity($entity);
        $this->validator->validate($task);
        $this->commandTaskRepository->save($task);

        return new CommandTaskOutput($task);
    }

    private function processDelete($data, Operation $operation, array $uriVariables = [], array $context = []): null
    {
        $user = $this->commandTaskRepository->findOneByUuid($uriVariables['uuid']);
        $this->commandTaskRepository->delete($user);

        return null;
    }
}
